package ru.dbotthepony.kstarbound.world

import ru.dbotthepony.kstarbound.math.Vector2i

class World(val seed: Long = 0L) {
	val chunkMap = ArrayList<Pair<ChunkPos, Chunk>>()

	fun getChunk(pos: ChunkPos): Chunk? {
		for ((k, v) in chunkMap) {
			if (k == pos) {
				return v
			}
		}

		return null
	}

	fun getChunk(pos: Vector2i) = getChunk(ChunkPos(pos))

	fun getOrMakeChunk(pos: ChunkPos): Chunk {
		for ((k, v) in chunkMap) {
			if (k == pos) {
				return v
			}
		}

		val chunk = Chunk(this, pos)
		chunkMap.add(pos to chunk)
		return chunk
	}

	fun getOrMakeChunk(pos: Vector2i) = getOrMakeChunk(ChunkPos(pos))

	fun getTile(pos: Vector2i): ChunkTile? {
		return getChunk(pos)?.get(pos.x, pos.y)
	}

	fun setTile(pos: Vector2i, tile: ChunkTile?): Chunk {
		val chunk = getOrMakeChunk(pos)
		chunk[pos.x and CHUNK_SIZE_FF, pos.y and CHUNK_SIZE_FF] = tile
		return chunk
	}
}
